/*
 * Main.java
 *
 * Created on 9. listopad 2006, 19:07
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package uloha2;

import java.util.ArrayList;
import java.util.Date;
import java.util.Random;

/**
 *
 * @author zelial
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //pocet uspechu pro jednotlive heuristiky
        int uspechChybneUmisteni = 0;
        int uspechManhattanskaVzdalenost = 0;
        //pocet kroku po uspesne pokusy
        int uspechKrokuUmisteni =0;
        int uspechKrokuManhattanskaVzdalenost = 0;
        //pocet pokusu
        final int pokusu = 10000;
        //maximalni pocet kroku pro jedno reseni
        int maxKroku = 125;
        //pocitadlo kroku
        int krok = 0;
        //rika, zda jsme nasli reseni nebo ne
        boolean hotovo = false;
        Random rnd = new Random(new Date().getTime());
        //seznam vhodnych tahu - vyberem jeden nahodne
         ArrayList<Board> tahy =  new ArrayList<Board>();
    for (int cyklus = 0 ; cyklus < pokusu ; cyklus++){
        try{
         Board startovniPozice = new Board();
         //pomocne hraci pole pro vyhodnocovani vhodnosti tahu + dve pro provadeni tahu
         Board left,right,up,down,aktualni, dalsi;
         /**
          ** chybne umisteni
          **/
         krok = 0;
         hotovo = false;
         aktualni = new Board(startovniPozice);
         dalsi = new Board(startovniPozice);
         if (aktualni.getHeurChyba() == 0){
                 hotovo = true;
         }
         while (!hotovo && krok <maxKroku){
             tahy.clear();
             //System.out.println("krok: "+krok);
             //System.out.println("vzdalenost: "+aktualni.getHeurChyba());
             //System.out.println(aktualni.getComment());
             //System.out.println(aktualni.toString());
             if (aktualni.getHeurChyba() == 0){
                 hotovo = true;
             }
             int miniHodnoceni = 99999999;
             
             left = new Board(aktualni);
             if (left.moveLeft()){
                 if ( miniHodnoceni > left.getHeurChyba()){
                    tahy.clear();
                    tahy.add(left);
                    miniHodnoceni = left.getHeurChyba();
                    left.setComment("left");
                 }else if ( miniHodnoceni == left.getHeurChyba()){
                       tahy.add(left);
                       left.setComment("left");
                 }
                 //System.out.println("l-man: "+left.getHeurChyba());
                 //System.out.println("l-man: \n"+left.toString());
             }
             up = new Board(aktualni);
             if (up.moveUp()){
                 if (miniHodnoceni > up.getHeurChyba()){
                     tahy.clear();
                     tahy.add(up);
                     miniHodnoceni = up.getHeurChyba();
                     up.setComment("up");
                 }else if (miniHodnoceni == up.getHeurChyba()){
                        tahy.add(up);
                        up.setComment("up");
                 }
                 //System.out.println("u-man: "+up.getHeurChyba());
                 //System.out.println("u-man: \n"+up.toString());
             }
             right = new Board(aktualni);
             if (right.moveRight()){
                 if (miniHodnoceni > right.getHeurChyba()){
                     tahy.clear();
                     tahy.add(right);
                    miniHodnoceni = right.getHeurChyba();
                    right.setComment("right");
                 }else if(miniHodnoceni == up.getHeurChyba()){
                     tahy.add(right);
                     right.setComment("right");
                 }
                //System.out.println("r-man: "+right.getHeurChyba());
                //System.out.println("r-man: \n"+right.toString());
             }
             
             down = new Board(aktualni);
             if (down.moveDown()){
                 if (miniHodnoceni > down.getHeurChyba()){
                    tahy.clear();
                    tahy.add(down);
                    miniHodnoceni = down.getHeurChyba();
                    down.setComment("down");
                 }else if (miniHodnoceni == up.getHeurChyba()){
                     tahy.add(down);
                     down.setComment("down");
                 }
                 //System.out.println("d-man: "+down.getHeurChyba());
                 //System.out.println("d-man: \n"+down.toString());
             }
             //System.out.println("moznych tahu: "+tahy.size());
             aktualni = new Board(tahy.get(Math.abs(rnd.nextInt())%tahy.size()));
             krok++;
         }
         if (hotovo){
             System.out.println("chybne umisteni: reseni nalezeno v "+krok+" krocich");
             uspechChybneUmisteni++;
             uspechKrokuUmisteni +=krok;
         }else{
             //System.out.println("chybne umisteni: reseni nenalezeno");
         }
         /**
          ** manhattanska vzdalenost
          **/
         krok = 0;
         hotovo = false;
         aktualni = new Board(startovniPozice);
         dalsi = new Board(startovniPozice);
         if (aktualni.getHeurManhattan() == 0){
                 hotovo = true;
         }
         while (!hotovo && krok <maxKroku){
             tahy.clear();
             //System.out.println("krok: "+krok);
             //System.out.println("vzdalenost: "+aktualni.getHeurManhattan());
             //System.out.println(aktualni.getComment());
             //System.out.println(aktualni.toString());
             if (aktualni.getHeurManhattan() == 0){
                 hotovo = true;
             }
             int miniHodnoceni = 99999999;
             
             left = new Board(aktualni);
             if (left.moveLeft()){
                 if ( miniHodnoceni > left.getHeurManhattan()){
                    tahy.clear();
                    tahy.add(left);
                    miniHodnoceni = left.getHeurManhattan();
                    left.setComment("left");
                 }else if ( miniHodnoceni == left.getHeurManhattan()){
                       tahy.add(left);
                       left.setComment("left");
                 }
                 //System.out.println("l-man: "+left.getHeurManhattan());
                 //System.out.println("l-man: \n"+left.toString());
             }
             up = new Board(aktualni);
             if (up.moveUp()){
                 if (miniHodnoceni > up.getHeurManhattan()){
                     tahy.clear();
                     tahy.add(up);
                     miniHodnoceni = up.getHeurManhattan();
                     up.setComment("up");
                 }else if (miniHodnoceni == up.getHeurManhattan()){
                        tahy.add(up);
                        up.setComment("up");
                 }
                 //System.out.println("u-man: "+up.getHeurManhattan());
                 //System.out.println("u-man: \n"+up.toString());
             }
             right = new Board(aktualni);
             if (right.moveRight()){
                 if (miniHodnoceni > right.getHeurManhattan()){
                     tahy.clear();
                     tahy.add(right);
                    miniHodnoceni = right.getHeurManhattan();
                    right.setComment("right");
                 }else if(miniHodnoceni == up.getHeurManhattan()){
                     tahy.add(right);
                     right.setComment("right");
                 }
                //System.out.println("r-man: "+right.getHeurManhattan());
                //System.out.println("r-man: \n"+right.toString());
             }
             
             down = new Board(aktualni);
             if (down.moveDown()){
                 if (miniHodnoceni > down.getHeurManhattan()){
                    tahy.clear();
                    tahy.add(down);
                    miniHodnoceni = down.getHeurManhattan();
                    down.setComment("down");
                 }else if (miniHodnoceni == up.getHeurManhattan()){
                     tahy.add(down);
                     down.setComment("down");
                 }
                 //System.out.println("d-man: "+down.getHeurManhattan());
                 //System.out.println("d-man: \n"+down.toString());
             }
             //System.out.println("moznych tahu: "+tahy.size());
             aktualni = new Board(tahy.get(Math.abs(rnd.nextInt())%tahy.size()));
             krok++;
         }
         if (hotovo){
             System.out.println("manhattanska vzdalenost: reseni nalezeno v "+krok+" krocich");
             uspechManhattanskaVzdalenost++;
             uspechKrokuManhattanskaVzdalenost +=krok;
         }else{
             //System.out.println("manhattanska vzdalenost: reseni nenalezeno");
         }
        }catch (Exception e){
            System.err.println("neco je spatne:"+e.getMessage()+". za to asi budou body dolu ;)");
            e.printStackTrace();
        }
    }
        System.out.println("manhattanska vzdalenost - uspechu: "+uspechManhattanskaVzdalenost+"/"+pokusu);
        if (uspechManhattanskaVzdalenost >0){
            System.out.println("manhattanska vzdalenost - prumerny pocet tahu na reseni:"+uspechKrokuManhattanskaVzdalenost/uspechManhattanskaVzdalenost);
        }
        System.out.println("chybne umisteni - uspechu: "+uspechChybneUmisteni+"/"+pokusu);
        if (uspechChybneUmisteni >0){
            System.out.println("chybne umisteni - prumerny pocet tahu na reseni:"+uspechKrokuUmisteni/uspechChybneUmisteni);
        }
    }
    
}
